/*
 * Project: MoleCuilder
 * Description: creates and alters molecular systems
 * Copyright (C)  2010-2012 University of Bonn. All rights reserved.
 * 
 *
 *   This file is part of MoleCuilder.
 *
 *    MoleCuilder is free software: you can redistribute it and/or modify
 *    it under the terms of the GNU General Public License as published by
 *    the Free Software Foundation, either version 2 of the License, or
 *    (at your option) any later version.
 *
 *    MoleCuilder is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *    GNU General Public License for more details.
 *
 *    You should have received a copy of the GNU General Public License
 *    along with MoleCuilder.  If not, see <http://www.gnu.org/licenses/>.
 */

/*
 * BooleanQtQuery.cpp
 *
 *  Created on: Oct 25, 2010
 *      Author: heber
 */

// include config.h
#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#include <Qt/qboxlayout.h>
#include <Qt/qcheckbox.h>
#include <Qt/qlabel.h>

//#include "CodePatterns/MemDebug.hpp"

#include "UIElements/Qt4/Query/QtQuery.hpp"


QtDialog::BooleanQtQuery::BooleanQtQuery(Parameter<bool> &_param, const std::string &_title, const std::string &_description, QBoxLayout *_parent, Dialog *_dialog) :
    QtQuery<bool>(_param, _title, _description),
    parent(_parent),
    dialog(_dialog)
{
  temp = false;
  if (param.isSet())
    temp = param.get();
  thisLayout = new QHBoxLayout();
  titleLabel = new QLabel(QString(getTitle().c_str()));
  titleLabel->setToolTip(QString(getDescription().c_str()));
  booleanCheckBox = new QCheckBox(QString(getTitle().c_str()));
  booleanCheckBox->setCheckState(temp ? Qt::Checked : Qt::Unchecked);

  parent->addLayout(thisLayout);
  thisLayout->addWidget(titleLabel);
  thisLayout->addWidget(booleanCheckBox);

  connect(booleanCheckBox, SIGNAL(stateChanged(int)), this, SLOT(onUpdate(int)));
}

QtDialog::BooleanQtQuery::~BooleanQtQuery()
{
}

void QtDialog::BooleanQtQuery::onUpdate(int state) {
  temp = (state == Qt::Checked);
  QtQuery<bool>::handle();
  dialog->update();
}


